From 9007e46b033c43ddb16215b723e03a73883dc35f Mon Sep 17 00:00:00 2001
From: David Tolnay <dtolnay@gmail.com>
Date: Dec 11 2020 22:05:12 +0000
Subject: [PATCH 1699/2232] Add Vec copy constructor


---

diff --git a/include/cxx.h b/include/cxx.h
index 86de118..22636fd 100644
--- a/include/cxx.h
+++ b/include/cxx.h
@@ -241,6 +241,7 @@ public:
 
   Vec() noexcept;
   Vec(std::initializer_list<T>);
+  Vec(const Vec &);
   Vec(Vec &&) noexcept;
   ~Vec() noexcept;
 
@@ -649,6 +650,12 @@ Vec<T>::Vec(std::initializer_list<T> init) : Vec{} {
 }
 
 template <typename T>
+Vec<T>::Vec(const Vec &other) : Vec() {
+  this->reserve_total(other.size());
+  std::copy(other.begin(), other.end(), std::back_inserter(*this));
+}
+
+template <typename T>
 Vec<T>::Vec(Vec &&other) noexcept : repr(other.repr) {
   new (&other) Vec();
 }

